<?
/* 
   This file is part of the 'Science Fair In A Box' project
   SFIAB Website: http://www.sfiab.ca

   Copyright (C) 2005 Sci-Tech Ontario Inc <info@scitechontario.org>
   Copyright (C) 2005 James Grant <james@lightbox.org>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
?>
<?
 require("../common.inc.php");
 auth_required('config');
 send_header("Year Rollover");
 ?>

 <script language="javascript" type="text/javascript">
 function confirmYearRollover()
 {
 	var currentyear=<?=$config['FAIRYEAR']?>;
	var nextyear=document.forms.rollover.nextfairyear.value;
	if(nextyear<currentyear)
		alert('You cannot roll backwards in years!');
	else if(nextyear==currentyear)
		alert('You cannot roll to the same year!');
	else
	{

		var okay=confirm('Are you sure you want to roll the FAIRYEAR from '+currentyear+' to '+nextyear+'? This can not be undone and should only be done if you are absolutely sure!');
		if(okay)
			return true; 
	}
	return false;
 }
 </script>
 <?

 echo "<a href=\"index.php\">&lt;&lt; ".i18n("Back to Configuration")."</a><br />";

 if($_POST['action']=="rollover" && $_POST['nextfairyear'])
 {
 	$newfairyear=$_POST['nextfairyear'];
	$currentfairyear=$config['FAIRYEAR'];

	if($newfairyear<$currentfairyear)
		echo error(i18n("You cannot roll backwards in years!"));
	else if($newfairyear==$currentfairyear)
		echo error(i18n("You cannot roll to the same year!"));
	else
	{
		//okay here we go! this is going to get to be a pretty big script me thinks!

		//first, lets do all of the configuration variables
		echo i18n("Rolling configuration variables")."<br />";
		$q=mysql_query("SELECT * FROM config WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO config (var,val,category,ord,description,year) VALUES (
				'".mysql_escape_string($r->var)."',
				'".mysql_escape_string($r->val)."',
				'".mysql_escape_string($r->category)."',
				'".mysql_escape_string($r->ord)."',
				'".mysql_escape_string($r->description)."',
				'".mysql_escape_string($newfairyear)."')");

		//now the dates
		echo i18n("Rolling dates")."<br />";
		$q=mysql_query("SELECT DATE_ADD(date,INTERVAL 365 DAY) AS newdate,name,description FROM dates WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO dates (date,name,description,year) VALUES (
				'".mysql_escape_string($r->newdate)."',
				'".mysql_escape_string($r->name)."',
				'".mysql_escape_string($r->description)."',
				'".mysql_escape_string($newfairyear)."')");
		

		//page text
		echo i18n("Rolling page texts")."<br />";
		$q=mysql_query("SELECT * FROM pagetext WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO pagetext (textname,text,year) VALUES (
				'".mysql_escape_string($r->textname)."',
				'".mysql_escape_string($r->text)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Rolling project categories")."<br />";
		//project categories
		$q=mysql_query("SELECT * FROM projectcategories WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO projectcategories (id,category,mingrade,maxgrade,year) VALUES (
				'".mysql_escape_string($r->id)."',
				'".mysql_escape_string($r->category)."',
				'".mysql_escape_string($r->mingrade)."',
				'".mysql_escape_string($r->maxgrade)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Rolling project divisions")."<br />";
		//project divisions
		$q=mysql_query("SELECT * FROM projectdivisions WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO projectdivisions (id,division,division_shortform,year) VALUES (
				'".mysql_escape_string($r->id)."',
				'".mysql_escape_string($r->division)."',
				'".mysql_escape_string($r->division_shortform)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Rolling project sub-divisions")."<br />";
		//project subdivisions
		$q=mysql_query("SELECT * FROM projectsubdivisions WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO projectsubdivisions (id,projectdivisions_id,subdivision,year) VALUES (
				'".mysql_escape_string($r->id)."',
				'".mysql_escape_string($r->projectsubdivisions_id)."',
				'".mysql_escape_string($r->subdivision)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Rolling safety questions")."<br />";
		//safety questions 
		$q=mysql_query("SELECT * FROM safetyquestions WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO safetyquestions (question,type,required,ord,year) VALUES (
				'".mysql_escape_string($r->question)."',
				'".mysql_escape_string($r->type)."',
				'".mysql_escape_string($r->required)."',
				'".mysql_escape_string($r->ord)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Unconfirming award sponsors")." <br />";
		mysql_query("UPDATE award_sponsors SET confirmed='no'");

		echo i18n("Rolling awards")."<br />";
		//awards
		$q=mysql_query("SELECT * FROM award_awards WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
		{
			mysql_query("INSERT INTO award_awards (award_sponsors_id,award_types_id,name,criteria,presenter,`order`,year,excludefromac,cwsfaward) VALUES (
				'".mysql_escape_string($r->award_sponsors_id)."',
				'".mysql_escape_string($r->award_types_id)."',
				'".mysql_escape_string($r->name)."',
				'".mysql_escape_string($r->criteria)."',
				'".mysql_escape_string($r->presenter)."',
				'".mysql_escape_string($r->order)."',
				'".mysql_escape_string($newfairyear)."',
				'".mysql_escape_string($r->excludefromac)."',
				'".mysql_escape_string($r->cwsfaward)."')");
			$award_awards_id=mysql_insert_id();
			
			$q2=mysql_query("SELECT * FROM award_awards_projectcategories WHERE year='$currentfairyear' AND award_awards_id='$r->id'");
			echo mysql_error();
			while($r2=mysql_fetch_object($q2))
			{
				mysql_query("INSERT INTO award_awards_projectcategories (award_awards_id,projectcategories_id,year) VALUES (
				'".mysql_escape_string($award_awards_id)."',
				'".mysql_escape_string($r2->projectcategories_id)."',
				'".mysql_escape_string($newfairyear)."')");

			}

			$q2=mysql_query("SELECT * FROM award_awards_projectdivisions WHERE year='$currentfairyear' AND award_awards_id='$r->id'");
			echo mysql_error();
			while($r2=mysql_fetch_object($q2))
			{
				mysql_query("INSERT INTO award_awards_projectdivisions (award_awards_id,projectdivisions_id,year) VALUES (
				'".mysql_escape_string($award_awards_id)."',
				'".mysql_escape_string($r2->projectdivisions_id)."',
				'".mysql_escape_string($newfairyear)."')");

			}

			echo i18n("&nbsp; Rolling award prizes")."<br />";
			$q2=mysql_query("SELECT * FROM award_prizes WHERE year='$currentfairyear' AND award_awards_id='$r->id'");
			echo mysql_error();
			while($r2=mysql_fetch_object($q2))
			{
				mysql_query("INSERT INTO award_prizes (award_awards_id,cash,scholarship,`value`,prize,number,`order`,year,excludefromac) VALUES (
				'".mysql_escape_string($award_awards_id)."',
				'".mysql_escape_string($r2->cash)."',
				'".mysql_escape_string($r2->scholarship)."',
				'".mysql_escape_string($r2->value)."',
				'".mysql_escape_string($r2->prize)."',
				'".mysql_escape_string($r2->number)."',
				'".mysql_escape_string($r2->order)."',
				'".mysql_escape_string($newfairyear)."',
				'".mysql_escape_string($r2->excludefromac)."')");
			}
		}

		echo i18n("Rolling award contacts")."<br />";
		//award contacts
		$q=mysql_query("SELECT * FROM award_contacts WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO award_contacts (award_sponsors_id,salutation,firstname,lastname,position,email,phonehome,phonework,phonecell,fax,notes,year) VALUES (
				'".mysql_escape_string($r->award_sponsors_id)."',
				'".mysql_escape_string($r->salutation)."',
				'".mysql_escape_string($r->firstname)."',
				'".mysql_escape_string($r->lastname)."',
				'".mysql_escape_string($r->position)."',
				'".mysql_escape_string($r->email)."',
				'".mysql_escape_string($r->phonehome)."',
				'".mysql_escape_string($r->phonework)."',
				'".mysql_escape_string($r->phonecell)."',
				'".mysql_escape_string($r->fax)."',
				'".mysql_escape_string($r->notes)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Rolling award types")."<br />";
		//award types
		$q=mysql_query("SELECT * FROM award_types WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO award_types (id,type,`order`,year) VALUES (
				'".mysql_escape_string($r->id)."',
				'".mysql_escape_string($r->type)."',
				'".mysql_escape_string($r->order)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Rolling schools")."<br />";
		//award types
		$q=mysql_query("SELECT * FROM schools WHERE year='$currentfairyear'");
		echo mysql_error();
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO schools (school,schoollang,schoollevel,board,district,phone,fax,address,city,province_code,postalcode,principal,schoolemail,sciencehead,scienceheademail,scienceheadphone,accesscode,lastlogin,junior,intermediate,senior,registration_password,projectlimit,projectlimitper,year) VALUES (
				'".mysql_escape_string($r->school)."',
				'".mysql_escape_string($r->schoollang)."',
				'".mysql_escape_string($r->schoollevel)."',
				'".mysql_escape_string($r->board)."',
				'".mysql_escape_string($r->district)."',
				'".mysql_escape_string($r->phone)."',
				'".mysql_escape_string($r->fax)."',
				'".mysql_escape_string($r->address)."',
				'".mysql_escape_string($r->city)."',
				'".mysql_escape_string($r->province_code)."',
				'".mysql_escape_string($r->postalcode)."',
				'".mysql_escape_string($r->principal)."',
				'".mysql_escape_string($r->schoolemail)."',
				'".mysql_escape_string($r->sciencehead)."',
				'".mysql_escape_string($r->scienceheademail)."',
				'".mysql_escape_string($r->scienceheadphone)."',
				'".mysql_escape_string($r->accesscode)."',
				NULL,
				'".mysql_escape_string($r->junior)."',
				'".mysql_escape_string($r->intermediate)."',
				'".mysql_escape_string($r->senior)."',
				'".mysql_escape_string($r->registration_password)."',
				'".mysql_escape_string($r->projectlimit)."',
				'".mysql_escape_string($r->projectlimitper)."',
				'".mysql_escape_string($newfairyear)."')");

		echo i18n("Rolling questions")."<br />";
		$q = mysql_query("SELECT * FROM questions WHERE year='$currentfairyear'");
		while($r=mysql_fetch_object($q))
			mysql_query("INSERT INTO questions (id,year,section,db_heading,question,type,required,ord) VALUES (
				'',
				'$newfairyear',
				'".mysql_escape_string($r->section)."',
				'".mysql_escape_string($r->db_heading)."',
				'".mysql_escape_string($r->question)."',
				'".mysql_escape_string($r->type)."',
				'".mysql_escape_string($r->required)."',
				'".mysql_escape_string($r->ord)."')");

		echo "<br />";
		echo "<br />";
		mysql_query("UPDATE config SET val='$newfairyear' WHERE var='FAIRYEAR' AND year=0");
		echo happy(i18n("Fair year has been rolled over from %1 to %2",array($currentfairyear,$newfairyear)));
		send_footer();
		exit;
	}
 }

 echo "<br />";
 echo "<form name=\"rollover\" method=\"post\" action=\"rollover.php\" onsubmit=\"return confirmYearRollover()\">";
 echo "<input type=\"hidden\" name=\"action\" value=\"rollover\" />";
 echo i18n("Current Fair Year").": <b>".$config['FAIRYEAR']."</b><br />";
 $nextfairyear=$config['FAIRYEAR']+1;
 echo i18n("Next Fair Year").": <input size=\"8\" type=\"text\" name=\"nextfairyear\" value=\"$nextfairyear\" />";
 echo "<br />";
 echo "<input type=\"submit\" value=\"".i18n("Rollover Fair Year")."\" />";
 echo "</form>";

 send_footer();
?>
